/*
 * File: MyGame.js 
 * This is the logic of our game. For now, this is very simple.
 */
/*jslint node: true, vars: true */
/*global gEngine: false, SimpleShader: false, Renderable: false, Camera: false, mat4: false, vec3: false, vec2: false */
/* find out more about jslint: http://www.jslint.com/help.html */

"use strict";  // Operate in Strict mode such that variables must be declared before used!

function MyGame(htmlCanvasID) {
    // variables of the shader for drawing: one shader to be shared by two renderables
    this.mConstColorShader = null;

    // variables for the squares
    this.mBlueSq = null;        // these are the Renderable objects
    this.mRedSq = null;

    // Step A: Initialize the webGL Context
    gEngine.Core.initializeWebGL(htmlCanvasID);

    // Step B: Setup the camera
    this.mCamera = new Camera(
        vec2.fromValues(30, 40),   // center of the WC
        40,                        // width of WC
        [0, 0, 100, 200]         // viewport (orgX, orgY, width, height)
        );

/*
 *  (b)
 *
 this.mCamera = new Camera(
        	vec2.fromValues(30, 40),   	// center of the WC
        	40,                        		// width of WC
        	[250, 100, 100, 200]         	// viewport (orgX, orgY, width, height)
        	);
*/

 /*
  * ()
  *
 this.mCamera = new Camera(
vec2.fromValues(30, 40),   // center of the WC
        	20,                        // width of WC
        	[250, 175, 100, 50]         // viewport (orgX, orgY, width, height)
        );
*/

    // Step C: Create the shader
    this.mConstColorShader = new SimpleShader(
        "src/GLSLShaders/SimpleVS.glsl",      // Path to the VertexShader 
        "src/GLSLShaders/SimpleFS.glsl");    // Path to the simple FragmentShader

    // Step D: Create the Renderable objects:
    this.mBlueSq = new Renderable(this.mConstColorShader);
    this.mBlueSq.setColor([0.25, 0.25, 0.95, 1]);

    // Step E: Clear the canvas
    gEngine.Core.clearCanvas([0.9, 0.9, 0.9, 1]);        // Clear the canvas

    // Step F: Starts the drawing by activating the camera
    this.mCamera.setupViewProjection();
    var vpMatrix = this.mCamera.getVPMatrix();

    // Step G: Draw the blue square
    // Centre Blue, slightly rotated square
    this.mBlueSq.getXform().setPosition(30, 40);
    this.mBlueSq.getXform().setSize(20, 15);
    this.mBlueSq.draw(vpMatrix);
}